import _extends from "@babel/runtime/helpers/esm/extends";

var _require = require('@pactflow/pact-msw-adapter/dist/utils/utils'),
    writeData2File = _require.writeData2File;

var _require2 = require('@s-ui/js/lib/string'),
    toQueryString = _require2.toQueryString;

var writerFactory = function writerFactory(providers) {
  return function (path, data) {
    var interactions = data.interactions,
        provider = data.provider;
    var name = provider.name;
    data.interactions = interactions.map(function (interaction) {
      var request = interaction.request;
      var path = request.path,
          query = request.query;
      var definedInteraction = providers[name].find(function (_ref) {
        var endpoint = _ref.endpoint,
            definedQuery = _ref.query;
        var matchedEndpoint = endpoint === path;

        if (query) {
          return matchedEndpoint && query === toQueryString(definedQuery);
        }

        return matchedEndpoint;
      });
      var description = definedInteraction.description,
          providerState = definedInteraction.state;
      return _extends({}, interaction, {
        description: description,
        providerState: providerState
      });
    });
    writeData2File(path, data);
  };
};

var mapProviders = function mapProviders(providers) {
  return Object.keys(providers).reduce(function (reducedProviders, key) {
    var _extends2;

    var endpoints = providers[key].map(function (_ref2) {
      var endpoint = _ref2.endpoint,
          query = _ref2.query;
      return query ? endpoint + "?" + toQueryString(query) : endpoint;
    });
    return _extends({}, reducedProviders, (_extends2 = {}, _extends2[key] = endpoints, _extends2));
  }, {});
};

var getContractTests = function getContractTests(_ref3) {
  var apiUrl = _ref3.apiUrl,
      providers = _ref3.providers;
  return Object.keys(providers).reduce(function (tests, key) {
    return [].concat(tests, providers[key]);
  }, []);
};

module.exports = {
  writerFactory: writerFactory,
  mapProviders: mapProviders,
  getContractTests: getContractTests
};